# This file is the entry point to configure your own services.
# Files in the packages/ subdirectory configure your dependencies.

# Put parameters here that don't need to change on each machine where the app is deployed
# https://symfony.com/doc/current/best_practices.html#use-parameters-for-application-configuration
parameters:

services:
    # default configuration for services in *this* file
    _defaults:
        autowire: true      # Automatically injects dependencies in your services.
        autoconfigure: true # Automatically registers your services as commands, event subscribers, etc.

     # Register the custom Twig extension
    App\Service\GlobalObject:
        factory: ['App\Service\GlobalObjectFactory', 'create']  # Usa la fábrica para crear el objeto

    App\Twig\GlobalVariablesExtension:
        arguments:
            $globalObject: '@App\Service\GlobalObject'  # Aquí se inyecta la instancia de GlobalObject
            $requestStack: '@request_stack'
        tags: ['twig.extension']
    
    # EventSubscriber
    App\EventSubscriber\UserSubscriber:
        arguments:
            $twig: '@twig'
            $router: '@router'
            $session: '@session'
        tags:
            - { name: 'kernel.event_subscriber' }

    App\EventSubscriber\ControllerAccessSubscriber:
        arguments:
            $router: '@router'
        tags:
            - { name: kernel.event_subscriber }

    App\EventSubscriber\NotFoundSubscriber:
        arguments:
            $router: '@router'
        tags:
            - { name: kernel.event_subscriber }


    
    # makes classes in src/ available to be used as services
    # this creates a service per class whose id is the fully-qualified class name
    App\:
        resource: '../src/'
        exclude:
            - '../src/DependencyInjection/'
            - '../src/Entity/'
            - '../src/Kernel.php'

    # add more service definitions when explicit configuration is needed
    # please note that last definitions always *replace* previous ones

